<template>
  <v-container id="input-usage" fluid>
    <v-img
      class="mx-auto my-6"
      max-width="228"
      src=""
    ></v-img>
      <v-card
      class="mx-auto pa-4 pb-8"
      elevation="8"
      max-width="500"
      rounded="lg"
      >
        <v-card-item>
          <v-card-title>
           <p class="text-h4 ">Chọn file nhập hàng</p>
          </v-card-title>
        </v-card-item>

        <v-card-text>
          <v-row>
            <v-col cols="12">
              <v-file-input
                  show-size
                  accept="files/xlsx"
                  counter
                  multiple
                  ref="file"
                  label="files upload"
                  variant="solo-filled"
                  @change="handleFileUpload()"
                >Nhập file
                </v-file-input>

                <div>
                  <v-btn
                  class="me-4"
                  type="submit"
                  :loading="loading"
                  :disabled="disabled == 1"
                  @click="submitFileUpload()"
                >
                  Lưu
                </v-btn>
                </div>
            </v-col>
          </v-row>
        </v-card-text>
        <v-card-item>
          <v-card-subtitle>
            <v-alert
              v-model="alert"
              border="left"
              close-text="Close Alert"
              color="error"
              dark
              dismissible
              max-width="450"
              height="auto"
              class="">
              <div style="overflow-x:auto; white-space: nowrap;" v-html="message"></div>
            </v-alert>
          </v-card-subtitle>
        </v-card-item>
      </v-card>
    <modal-login ref="showModal" dialog />
    
  </v-container>
</template>
<script>
  import ModalLogin from '@/components/ModalLogin';
  import { useCookies } from 'vue3-cookies';
  import { uploadFile } from '@/api/upload'
  import swal from 'sweetalert2';
  export default {
    setup(){
      const {cookies} = useCookies();
      return {cookies}
    },
    data(){
      return {
        file: '',
        message:'',
        alert : false,
        disabled : 1,
        type:false,
        value:null,
        dataInfo: null,
        loading:false
      }
    },
    components:{
      ModalLogin
    },
    methods:{
      handleFileUpload(){
        this.file = this.$refs.file.files[0];
        if(!this.file || this.file.name.split(".").pop() != 'xlsx'){//check if file extension is xlsx
          swal.fire('Đã có lỗi', 'Vui lòng chọn file định dạng .xlsx','error');
          this.disabled = 1
          return;
        } else {
          this.alert = false
          this.disabled = 0
        }
      },
      submitFileUpload(){
         let token = this.cookies.get('token');
        if(!token) {
          this.$refs.showModal.dialog = true
          return
        }
        this.loading = true
        let formData = new FormData();
        formData.append("import_excel_file", this.file)
        uploadFile(formData).then(res=>{
          let data = res.data
          if(data){
          swal.fire('Thành công', 'Nhập file thành công','success');
          window.location.reload();
          }
        })
        .catch((err)=> {
          console.log(err)
          this.alert = true
          let arrErr = err.response.data;
          if(arrErr) {
            if((arrErr.data.length>0)){
              swal.fire(arrErr.message, '','error');
              this.message = arrErr.data.join('<br/>')
            } else {
              this.message = arrErr.message
            }
            return
          }
          this.message = 'Lỗi hệ thống'
          return
        }).finally(()=>{
          this.loading = false;
          
        })
      }
    }
  }
</script>
